#!/usr/X11/bin/wish

wm minsize . 300 50

wm title . "BlindPenguin"

#This will create the menubar and options

set f [frame .menubar]
pack $f -fill x

menubutton $f.file -text File  -underline 0  -menu $f.file.m
set m [menu $f.file.m -tearoff 1]

menubutton $f.opt -text Options -underline 0 -menu $f.opt.m
set l [menu $f.opt.m -tearoff 1]

menubutton $f.help -text Help -underline 0 -menu $f.help.m
set p [menu $f.help.m -tearoff 1]

pack $f.file $f.opt $f.help -side left

$m add command -label "Load Config"  -command {openfile}
$m add separator
$m add command -label "Save Config" -command {savefile $size}
$m add command -label "Save As.." -command {saveas}
$m add separator
$m add command -label "Exit" -command exit

$l add cascade -label "Set Size.." -menu $l.l
set m1 [menu $l.l -tearoff 1]
$m1 add check -label "X 2" -variable X2 -command {set_size "2"}
$m1 add check -label "X 3" -variable X3 -command {set_size "3"}
$m1 add check -label "X 4" -variable X4 -command {set_size "4"}
$m1 add check -label "X 5" -variable X5 -command {set_size "5"}
$m1 add check -label "X 6" -variable X6 -command {set_size "6"}


$p add cascade -label "Help Topics" -menu $p.3
set m3 [menu $p.3 -tearoff 1]

$m3 add cascade -label "General Help" -menu $p.3.1
set o [menu $p.3.1 -tearoff 1]
$m3 add separator

$o add command -label "System Requirements" -command {WebHelp}
$o add command -label "Installation" -command {WebHelp1}


$m3 add command -label "File Menu" -command {WebHelp2}
$m3 add command -label "Options Menu" -command {WebHelp3}
$m3 add command -label "Magnification Help" -command {WebHelp4}



$p add separator
$p add command -label About -command about


###############################################################

#This procedure passes down the size that the user will select

proc set_size {var} {
global size
set size $var
}



#This is where the size is saved to file   

proc savefile {size} {

global env

set configfile $env(HOME)
set pidfile $env(HOME)
set signal 1

append configfile "/.BlindPenguin"
append pidfile "/.BlindPenguin.pid"

set mysize [open $configfile w]

puts $mysize $size
puts $mysize $size

close $mysize

set myfile [open $pidfile r]
gets $myfile pids
close $myfile
eval exec [format "kill -%s" $signal] $pids

destroy .saveent

}




#This is where the size is saved to file when the user is over writing a
#file

proc savefile1 {size} {

destroy .saveent

global env

set configfile $env(HOME)
set pidfile $env(HOME)
set signal 1

append configfile "/.BlindPenguin"
append pidfile "/.BlindPenguin.pid"

set mysize [open $configfile w]

puts $mysize $size
puts $mysize $size

close $mysize

set myfile [open $pidfile r]
gets $myfile pids
close $myfile
eval exec [format "kill -%s" $signal] $pids



}




#This procedure is called when a file is entered in the Load Config option

proc openentry {entry} {

global ent
set ent $entry

 if [file exists $entry] {

  if [file isdirectory $entry] {
    cd $entry
    destroy .fs.files
    listbox .fs.files -relief raised -borderwidth 3 \
        -yscrollcommand ".fs.scroll set"

    pack .fs.files -side left

    list-out


} elseif [file exists $entry] {
 
    if [file isfile $entry] {

   global env
   set myfile $ent
   set myfile2 $env(HOME)

   append myfile2 "/.BlindPenguin"

   set InFile [open $myfile r]
   set OutFile [open $myfile2 w]
   while {-1 != [gets $InFile Line]} {
   puts $OutFile $Line

}
}

  destroy .fs

} 


} else {loaderr}
}



#This procedure puts the entry field in the Load Config box and when the
#user hits return after entering in a file to be opened it calls the
#openentry procedure 

proc file-entry {type} {
frame .fs.file
label .fs.file.label -text $type
entry .fs.file.entry -width 20 -relief sunken -bd 2 -textvariable entered
pack .fs.file.label .fs.file.entry -side left -padx 1m -pady 2m
global entry
focus .fs.file.entry
bind .fs.file.entry <Return> {openentry [.fs.file.entry get]}

pack .fs.file -side top

}



#This procedure puts the entry field in the Save As box and when the user
#hits return after entering in a file it calls the save-entry procedure

proc file-entry1 {type} {
frame .fs.file
label .fs.file.label -text $type
entry .fs.file.entry -width 20 -relief sunken -bd 2 -textvariable entered
pack .fs.file.label .fs.file.entry -side left -padx 1m -pady 2m

global entry
bind .fs.file.entry <Return> {save-entry [.fs.file.entry get]}

pack .fs.file -side top

}



#This procedure gives a list of all the files in the users home direcory

proc list-out {} {
.fs.files insert end .
.fs.files insert end ..
foreach i [lsort [glob *]] {
        .fs.files insert end $i
}
 
}



#This procedure saves the file name that the user enters in the entry field

proc save-entry {entry} {

global listent
set listent $entry
global env
global size

 if [file exists $entry] {  
  
      if [file isfile $entry] { 

       {saveerror}

}
} elseif {[file exists $entry] != 1} {
 
    if {[file isfile $entry] !=1} {
    
   set mysize [open $entry w]

puts $mysize $size
puts $mysize $size

destroy .fs
}

 savefile $size

}
}



#This is the list box for the Load Config option

proc list-box {} {

listbox .fs.files  -relief raised -borderwidth 4 \
        -yscrollcommand ".fs.scroll set"
pack .fs.files -side left
scrollbar .fs.scroll -command ".fs.files yview"
pack .fs.scroll -side right -fill y
list-out
global boxg
global entry
focus .fs.files
#bind .fs.files <ButtonPress-1><Return>  [list ListTransferSel %W $] 
bind .fs.files <ButtonPress-1><Button> {openentry [.fs.files get active]}
}


#This is the listbox for the Save As option

proc list-box1 {} {

listbox .fs.files  -relief raised -borderwidth 4 \
        -yscrollcommand ".fs.scroll set"
pack .fs.files -side left
scrollbar .fs.scroll -command ".fs.files yview"
pack .fs.scroll -side right -fill y
list-out
global boxg
global entry
focus .fs.files
bind .fs.files <ButtonPress-1><Button> {saveerror}
}



#This is the box for the open option

proc openfile {} {
toplevel .fs
wm title .fs "Select File:"
file-entry "Open File:"
button .fs.cancel -text "Cancel" -padx 5 -pady 5 -command {destroy .fs}
pack .fs.cancel -side left -padx 5

list-box

}

#This is the box for the save as option

proc saveas {} {
toplevel .fs
wm title .fs "Save File:"
file-entry1 "Save File:"
button .fs.cancel -text "Cancel" -padx 5 -pady 5 -command {destroy .fs}
pack .fs.cancel -side left -padx 5 -pady 5

list-box1
}



#This is the about box giving credit where owed to the team

proc about {} {
    toplevel .about -borderwidth 3
    wm title .about "About BlindPenguin"

    wm geometry .about 300x275
    
   message .about.members -justify left -text "BlindPenguin was completed in partial\ 
fulfilment of the requirements of the degree, BSc. in Commercial Software Development, in\ 
Waterford Institute of Technology.  

The students working on this project are:

       
    Kieran O'Sullivan
    Catherine Teahan
 
    
    Dated: 15th April 2000" 




    button .about.ok -text "OK"  -command "destroy .about"

    pack .about.members
    pack .about.ok -padx 3m -pady 3m
}


#These following procedures bring the user to the help files that are
#written in html

proc WebHelp {} {
	exec sh -c "netscape -install http://snet.wit.ie/BlindPenguin/help/systemrequirements.html"
}


proc WebHelp1 {} {
	exec sh -c "netscape -install http://snet.wit.ie/BlindPenguin/help/installation.html"

}

proc WebHelp2 {} {
        exec sh -c "netscape -install http://snet.wit.ie/BlindPenguin/help/help.html"

}

proc WebHelp3 {} {
        exec sh -c "netscape -install http://snet.wit.ie/BlindPenguin/help/options.html"

}


proc WebHelp4 {} {
        exec sh -c "netscape -install http://snet.wit.ie/BlindPenguin/help/magnification.html"

}



#This procedure warns the user that they are about to overwrite a file
 
proc saveerror {} {

destroy .fs
global size
toplevel .saveent -borderwidth 3

 wm title .saveent "Warning!"
 wm geometry .saveent 150x150


message .saveent.put  -justify left -text "This file already exists.\ 
Do you want to replace the existing file?"



button .saveent.ok -text "OK" -command {savefile1 $size}

button .saveent.cancel -text "Cancel" -command "destroy .saveent"


    pack .saveent.put
    pack .saveent.ok  .saveent.cancel  -side left -pady 10 -padx 10
}



#This procedure tells the user that the file they are opening does not exist

proc loaderr {} {

toplevel .load -borderwidth 3

wm title .load "ERROR!"
wm geometry .load 130x150

message .load.err -justify left -text "The File You Are Trying To Open Does\
Not Exist. Please Try Again."

button .load.ok -text "OK" -command "destroy .load"

pack .load.err
pack .load.ok -padx 3m -pady 3m
}